/**********************************************************************
$Id: nexus_utp.h,v 1.3 1997/10/21 02:37:35 freedman Exp $

$Source: /nfs/globus1/src/master/nexus_utp/nexus_utp.h,v $

$Log: nexus_utp.h,v $
Revision 1.3  1997/10/21 02:37:35  freedman
Changed prefixes of global variables to NEXUS_UTP_.

Revision 1.2  1997/10/20 23:57:02  freedman
Started renaming of functions from UTP_ to nexus_utp_

Revision 1.1  1997/07/23 22:04:09  tuecke
First pass at integrating Dave Kohr UTP timing package into nexus

Revision 1.2  1994/11/03 19:52:24  kohr
Move current source from RCS to CVS control.

Revision 1.1  1994/10/25  20:41:50  tuecke
An initial version of Dave Kohr's timing package

Public declarations for the Unnamed Timing Package (UTP).
**********************************************************************/

/*
Pre-CVS version information:

Revision 1.4  1994/11/03  02:24:36  kohr
Added support for key/value pairs with UTP_set_attribute().

Revision 1.3  1994/11/01  02:29:31  kohr
Added timer naming and disabling/enabling; other clean-up.

Revision 1.2  1994/10/07  03:54:26  kohr
Added UTP_reset_timer() and UTP_get_accum_time().

Revision 1.1  1994/09/14  06:03:12  kohr
Initial revision
*/

#ifndef _UTP_h_
#define _UTP_h_

/**********************************************************************
Publicly-accessible functions.
**********************************************************************/

extern int nexus_utp_init(unsigned numTimers, int mode);

extern void nexus_utp_set_filename(const char *outFilename);

extern void
nexus_utp_set_attribute(const char *keyStr, const char *keyArg,
		  const char *valueStr, ...);

extern void nexus_utp_start_timer(unsigned timerNumber);

extern void nexus_utp_stop_timer(unsigned timerNumber);

extern void nexus_utp_reset_timer(unsigned timerNumber);

extern void nexus_utp_disable_timer(unsigned timerNumber);

extern void nexus_utp_enable_timer(unsigned timerNumber);

extern void nexus_utp_disable_all_timers(void);

extern void nexus_utp_enable_all_timers(void);

extern const char *
nexus_utp_name_timer(unsigned timerNumber, const char *nameStr, ...);

extern void
nexus_utp_get_accum_time(unsigned timerNumber, double *time, int *precision);

extern void nexus_utp_shutdown(void);


/**********************************************************************
Publicly-accessible definitions.
**********************************************************************/

/*
Initialization modes.
*/

#define NEXUS_UTP_MODE_SHARED  0	/* Pick one of these. */
#define NEXUS_UTP_MODE_PRIVATE 1

			/* Strings for timer names and attribute keys and
			   values must be shorter than this. */
#define NEXUS_UTP_MAX_NAME_LENGTH 240
#define NEXUS_UTP_DEFAULT_TIMER_NAME ""

#define NEXUS_UTP_DEFAULT_OUT_FILE_NAME "utp_dump.txt"


#endif /* #ifndef _UTP_h_ */

